PRO vs_baseplotselect, state
  ;;
  common vs_block
  ;; Telescope settings...
  Telescopes = ['UT1', 'UT2', 'UT3', 'UT4']
  ;; read initial values
  Tel1Vec = (*state.Baseline)[0, *]
  Tel2Vec = (*state.Baseline)[1, *]
  ColVec = (*state.Baseline)[2, *]
  SelVec = (*state.BaseSelect)
  ;;
  ;; GUI Building
  ;;
  BselectBase = Widget_Base(title='Baseline Plot Setup', /col)
  BselectSubbase = intarr(state.NumBlines)
  BselectButtonBase = intarr(state.NumBlines)
  BselectButton = intarr(state.NumBlines)
  BselectColor = intarr(state.NumBlines)
  WID = intarr(state.NumBlines)
  FOR i=0, state.NumBlines-1 DO BEGIN
      BselectSubbase[i] = Widget_Base(BselectBase, /row)
      BselectButtonBase[i] = Widget_Base(BselectSubbase[i], /row, /non)
      BselectButton[i] = Widget_Button(BselectButtonBase[i], $
                                       font=vs_fonts[1], $
                                       val=Telescopes[Tel1Vec[i]] + $
                                       '--' + Telescopes[Tel2Vec[i]])
      Widget_Control, BselectButton[i], Set_Button=SelVec[i]
      BselectColor[i] = Widget_Draw(BselectSubbase[i], xsize=32, ysize=32, /button)
  ENDFOR 
  BselectControl = Widget_Base(BselectBase, /row)
  BselectCancel = Widget_Button(BselectControl, val='Cancel', font=vs_fonts[1])
  BselectOK = Widget_Button(BselectControl, val='OK', font=vs_fonts[1])
  Widget_Control, BselectBase, /realize
  FOR i=0, state.NumBlines-1 DO BEGIN
      Widget_Control, BselectColor[i], get_value=Dummy
      WID[i] = Dummy[0]
      wset, wid[i]
      tv, replicate(ColVec[i], 32)#(intarr(32)+1)
  ENDFOR 
  ;;
  ;; Start the event handling loop
  ;;
  Eflag = 0
  WHILE Eflag EQ 0 DO BEGIN
      Event = Widget_Event(BselectBase)
      WhichColor = (where(Event.ID EQ BselectColor))[0]
      WhichButton = (where(Event.ID EQ BselectButton))[0]
      IF vs_debug THEN print, WhichColor, WhichButton
      CASE 1 OF 
          total(WhichColor) NE -1:BEGIN
              ColVec[WhichColor] = vs_pickcol(ColVec[WhichColor], state=state)
              wset, wid[WhichColor]
              tv, replicate(ColVec[WhichColor], 32)#(intarr(32)+1)
              Widget_Control, Event.ID, /Clear_Events
          END
          total(WhichButton) NE -1:BEGIN
              SelVec[WhichButton] = Event.Select
          END 
          Event.ID EQ BselectOK:BEGIN
              *state.BaseSelect = SelVec
              (*state.BaseLine)[2, *] = ColVec
              eflag = 1
          END 
          Event.ID EQ BselectCancel:BEGIN
              eflag = 1
          END 
      ENDCASE 
  ENDWHILE 
  Widget_Control, BselectBase, /Clear_Events, /Destroy
END

