;; (c) 1999 M. Feldt <mfeldt@mpia-hd.mpg.de>
PRO vs_dispcuts, state, VISIBILITY = visibility
  COMMON vs_block
  ;;
  ;; initialize values
  ;;
  Scales = ['log', 'lin', 'sqr']
  IF NOT keyword_set(visibility) THEN BEGIN 
      CurrentScale = where(state.DispScale EQ Scales)
      LowCut = state.DispCutLow
      HiCut = state.DispCutHigh
  ENDIF ELSE BEGIN
      CurrentScale = where(state.VisScale EQ Scales)
      LowCut = state.VisCutLow
      HiCut = state.VisCutHigh
  ENDELSE 
  ;;
  ;; Build GUI
  ;;
  DispBase = Widget_Base(title='VS Image Display Control', /col)
  DispLabel = Widget_Label(DispBase, val='Scaling:', font=vs_fonts[1])
  DispSSelect = CW_Bgroup(DispBase, $
                          Scales, $
                          set_val=CurrentScale, $
                          font=vs_fonts[1], $
                          /row, $
                          /excl $
                         )
  DispSliderHC = CW_Fslider(DispBase, $
                            /Drag, $
                            /Edit, $
                            max=2.0, $
                            min=-0.2, $
                            val=HiCut, $
                            Title='High Cut (frac.)' $
                           )
  DispSliderLC = CW_Fslider(DispBase, $
                            /Drag, $
                            /Edit, $
                            max=1.0, $
                            min=-0.2, $
                            val=LowCut, $
                            Title='Low Cut (frac.)' $
                           )
  DispControl = Widget_Base(DispBase, /row)
  DispCancel = Widget_Button(DispControl, val='Cancel', font=vs_fonts[1])
  DispOK = Widget_Button(DispControl, val='OK', font=vs_fonts[1])
  ;;
  ;; Now start the event loop
  ;;
  Widget_Control, DispBase, /realize
  Eflag = 0 
  WHILE Eflag EQ 0 DO BEGIN
      Event = Widget_Event(DispBase)
      CASE Event.ID OF 
          DispCancel: Eflag = 1
          DispOK:BEGIN
              Eflag = 1
              Widget_Control, DispSliderLC, get_val=LowCut
              Widget_Control, DispSliderHC, get_val=HiCut
              IF NOT keyword_set(visibility) THEN BEGIN
                   state.DispCutLow = LowCut[0]
                   state.DispCutHigh = HiCut[0]
                   state.DispScale = Scales[CurrentScale]
               ENDIF ELSE BEGIN
                   state.VisCutLow = LowCut[0]
                   state.VisCutHigh = HiCut[0]
                   state.VisScale = Scales[CurrentScale]
               ENDELSE 
          END 
          DispSSelect:CurrentScale = Event.Value
          ELSE:
      ENDCASE 
  ENDWHILE 
  widget_control, DispBase, /Clear_Events, /Destroy
END 
